// Connection library: connect_frame.js   beta version 0.2  14 april 2000
//
// Copyright (C) 2000 Jean-Hugues Rety and Robert Kendall
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published 
// by the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public 
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
//
// THIS IS NOT AN OFFICIAL RELEASE BUT A CURRENT WORKING VERSION !!
//
// This library provides JavaScript tools for 
// hypertext literary writing in HTML.
//
// Important: this version is a prototype, functionalities may me 
// modified in future versions.
//
// Documentation: http://www.wordcircuits.com/connect
// e-mail: connection@wordcircuits.com
//

if (typeof(connectWin) == "undefined")
 var connectWin = window;

if (typeof(outputWin) == "undefined")
 var outputWin = window;

var h_relativeDir = h_relativeDirectory();

if (typeof(statusWin) == "undefined")
 var statusWin = outputWin;

if (typeof(linkColorDefault) == "undefined")
 var linkColorDefault = connectWin.linkColorDefault;

if (typeof(linkPrefixDefault) == "undefined")
 var linkPrefixDefault = connectWin.linkPrefixDefault;
if (typeof(linkSuffixDefault) == "undefined")
 var linkSuffixDefault = connectWin.linkSuffixDefault;

if (typeof(annotatedTextColorDefault) == "undefined")
  var annotatedTextColorDefault = connectWin.annotatedTextColorDefault;

// popup's management

if (typeof(popupTextDefault) == "undefined")
  var popupTextDefault = connectWin.popupTextDefault;

if (typeof(titlePopup) == "undefined")
  var titlePopup = connectWin.titlePopup;

if (typeof(popupTextColorDefault) == "undefined")
  var popupTextColorDefault = connectWin.popupTextColorDefault;

if (typeof(popupBgColorDefault) == "undefined")
  var popupBgColorDefault = connectWin.popupBgColorDefault;

if (typeof(popupAttDefault) == "undefined")
  var popupAttDefault = connectWin.popupAttDefault;

// status bar management

if (typeof(statusTextDefault) == "undefined")
  var statusTextDefault = connectWin.statusTextDefault;

if (typeof(titleStatus) == "undefined")
  var titleStatus = connectWin.titleStatus;

// Dead links management:

if (typeof(deadLinkColor) == "undefined")
  var deadLinkColor = connectWin.deadLinkColor;

if (typeof(deadLinkPopup) == "undefined")
  var deadLinkPopup = connectWin.deadLinkPopup;

if (typeof(deadLinkStatus) == "undefined")
  var deadLinkStatus = connectWin.deadLinkStatus;

if (typeof(deadLinkStyle) == "undefined")
  var deadLinkStyle = connectWin.deadLinkStyle;

if (typeof(annotatedTextCSS) == "undefined")
  var annotatedTextCSS = connectWin.annotatedTextCSS;

if (typeof(linkCSS) == "undefined")
  var linkCSS = connectWin.linkCSS;


//
// Initializations
//

if (typeof(noHistUpdate) == "undefined")
  addHist();
else
  if (noHistUpdate != true)
    addHist();

var popupText = popupTextDefault;

var statusText = statusTextDefault;

var popupBgColor = popupBgColorDefault;

var popupAtt = popupAttDefault;

var popupTextColor = popupTextColorDefault;

var linkClass = "link";

var linkColor = linkColorDefault;

var linkPrefix = linkPrefixDefault;

var linkSuffix = linkSuffixDefault;

var annotatedTextColor = annotatedTextColorDefault;


// Internal code
var h_popnb = 1;

Array.prototype.expanded=false;

function h_thisFile ()
// Returns the file name of the outputWin window location
{
var url = outputWin.location.href;
var i = url.lastIndexOf (connectWin.baseDirectory);
return (url.substring (i + connectWin.baseDirectory.length, url.length));
}

function h_thisDirectory ()
{
var url = outputWin.location.href;
return (url.substring (0,url.lastIndexOf("/")));
}

function h_relativeDirectory ()
{
var url = outputWin.location.href;
return (url.substring (url.lastIndexOf(connectWin.baseDirectory) + connectWin.baseDirectory.length +1,url.lastIndexOf("/") +1));
}

function h_show(object) 
// Sets the visibility attribute to visible
{ 
if (outputWin.document.layers && outputWin.document.layers[object]) 
  outputWin.document.layers[object].visibility = 'visible'; 
else if (outputWin.document.all) 
  {
  outputWin.document.all[object].style.visibility = 'visible'; 
  outputWin.document.all[object].style.zIndex = 100;
  }
}

function h_hide(object) 
// Sets the visibility attribute to hidden
{ 
if (outputWin.document.layers && outputWin.document.layers[object]) 
  outputWin.document.layers[object].visibility = 'hidden'; 
else if (outputWin.document.all) 
  outputWin.document.all[object].style.visibility = 'hidden'; 
}


function h_expand (args)
// Returns an array that contains a list of atomic arguments.
{
if (typeof(args.expanded) != 'undefined' && args.expanded == true)
  return(args);
var ind=0;
var argArray = new Array ();
for (var i=0 ; i<args.length ; i++)
  {
  if (typeof (args[i].sort) == "function")
    {
    var tmpArray = h_expand(args[i]); 
    for (var j=0 ; j<tmpArray.length ; j++)
      argArray[ind++]=tmpArray[j];
    }
  else argArray[ind++]=args[i];
  }
argArray.expanded=true;
return (argArray);
}

function h_initDir()
{connectWin.h_relativeDir = h_relativeDir;
}

function addHist (node)
{
if (addHist.arguments.length == 0)
  connectWin.addHist(h_thisFile());
else 
  {h_initDir();
  connectWin.addHist(node);
  } 
}

function makeFileName (ident)
{return connectWin.makeFileName(ident);}

function histArray ()
{return connectWin.histArray();}

function select(args)
{h_initDir();return connectWin.select(h_expand(select.arguments));}

function filter(args)
{h_initDir();return connectWin.filter(h_expand(filter.arguments));}

function conditionalFilter(args)
{h_initDir();return connectWin.conditionalFilter(h_expand(conditionalFilter.arguments));}

function random(args)
{return connectWin.random(h_expand(random.arguments));}

function nRandom(args)
{return connectWin.nRandom(h_expand(nRandom.arguments));}

function filteredRandom(args)
{h_initDir();return connectWin.filteredRandom(h_expand(filteredRandom.arguments));}

function oldest(args)
{h_initDir();return connectWin.oldest(h_expand(oldest.arguments));}

function filteredOlest(args)
{h_initDir();return connectWin.filteredOldest(h_expand(filteredOldest.arguments));}

function filteredFirst(args)
{h_initDir();return connectWin.filteredFirst(h_expand(filteredFirst.arguments));}

function conditionalRandom(args)
{h_initDir();return connectWin.conditionalRandom(h_expand(conditionalRandom.arguments));}

function conditionalFirst(args)
{h_initDir();return connectWin.conditionalFirst(h_expand(conditionalFirst.arguments));}

function earliest(args)
{h_initDir();return connectWin.earliest(h_expand(earliest.arguments));}

function latest(args)
{h_initDir();return connectWin.latest(h_expand(latest.arguments));}

function allVisited(args)
{h_initDir();return connectWin.allVisited(h_expand(allVisited.arguments));}

function someVisited(args)
{h_initDir();return connectWin.someVisited(h_expand(someVisited.arguments));}

function visitedFrom(args)
{h_initDir();
var arg = h_expand(visitedFrom.arguments);
if (arg.length == 1)
  return connectWin.visitedFrom(arg, h_thisFile());
else return connectWin.visitedFrom(arg);}

function visitedNotFrom(args)
{h_initDir();var arg = h_expand(visitedNotFrom.arguments);
if (arg.length == 1) 
  return connectWin.visitedNotFrom(arg, h_thisFile());
else return connectWin.visitedNotFrom(arg);}

function visitedOnlyFrom(args)
{h_initDir();var arg = h_expand(visitedOnlyFrom.arguments);
if (arg.length == 1)
  return connectWin.visitedOnlyFrom(arg,h_thisFile());
else return connectWin.visitedOnlyFrom(arg);}

function allLinked(args)
{h_initDir();var arg = h_expand(allLinked.arguments);
if (typeof (arg[0].location) == "undefined")
  return connectWin.allLinked(outputWin,arg);
else return connectWin.allLinked(arg);}

function someLinked(args)
{h_initDir();var arg = h_expand(someLinked.arguments);
if (typeof (arg[0].location) == "undefined")
  return connectWin.someLinked(outputWin,arg);
else return connectWin.someLinked(arg);}

function nbVisits(args)
{h_initDir();return connectWin.nbVisits(h_expand(nbVisits.arguments));}

function nbVisited(args)
{h_initDir();return connectWin.nbVisited(h_expand(nbVisited.arguments));}

function hist(rank)
{return connectWin.hist(rank);}

function histRank(node)
{h_initDir();return connectWin.histRank(node);}

function visited(node)
{h_initDir();return connectWin.visited(node);}

function notVisited(node)
{h_initDir();return connectWin.notVisited(node);}

function linked(node)
{h_initDir();return connectWin.linked([outputWin,node]);}

function notLinked(node)
{h_initDir();return connectWin.notLinked([outputWin,node]);}

function notVisitedAndNotLinked(node)
{h_initDir();return ( ! (connectWin.someVisited(node) || connectWin.someLinked([outputWin,node]) ) );}

function allLinksFollowed(frameArg)
{h_initDir();if (allLinksFollowed.arguments.length == 0)
  return(connectWin.allLinksFollowed(outputWin));
 else 
  return(connectWin.allLinksFollowed(frameArg));}

function age(node)
{h_initDir();return connectWin.age(node);}

function nbLinks(frameArg)
{h_initDir();if (nbLinks.arguments.length == 0)
  return(connectWin.nbLinks(outputWin));
 else 
  return(connectWin.nbLinks(frameArg));}

function nbLinksNotFollowed(frameArg)
{h_initDir();if (nbLinksNotFollowed.arguments.length == 0)
  return(connectWin.nbLinksNotFollowed(outputWin));
 else 
  return(connectWin.nbLinksNotFollowed(frameArg));}

function histEmpty()
{return connectWin.histEmpty();}




// End-user functions for writing and linking


function condJSCode (yesJavaScriptCode, cond, noJavaScriptCode)
// Conditional JavaScript code.
// _yesJavaScriptCode_ is  executed if _cond_ holds.
// _noJavaScriptCode_, if specified,  is executed if _cond_ does not hold.
{
if (cond)
  h_write("<SCRIPT type='text/javascript'>" +  yesJavaScriptCode + "</SCRIPT>");
else
  if ( typeof(noJavaScriptCode) == "string" )
    h_write("<SCRIPT type='text/javascript'>" + noJavaScriptCode + "</SCRIPT>");
}

function display (yesText, cond, noText)
// Displays conditional text, 
// possibly with popup or/and status text if specified
// (in this case, the text is displayed as a link with void target
// and color _annotatedTextColor_).
{
if (display.arguments.length == 1 || cond)
  h_display (yesText);
else
  if ( typeof(noText) == "string" )
    h_display (noText);

annotatedTextColor = annotatedTextColorDefault;
popupText = popupTextDefault;
statusText = statusTextDefault;
popupBgColor = popupBgColorDefault;
popupAtt = popupAttDefault;
popuptextColor = popupTextColorDefault;
linkPrefix = linkPrefixDefault;
linkSuffix = linkSuffixDefault;
linkClass = "link";
}

function h_display (text)
// Displays text, possibly with popup or/and status text if specified.
{
if (popupText == null && statusText == null)
  h_write (text);
else
  {
  if (statusText == null)
    statusText = " ";
  linkColor = annotatedTextColor;
  linkClass = "annotatedText";
  h_link("javascript:void(0)", text);
  linkColor = linkColorDefault;
  }
}


function h_write (text)
// Writes text on the outputWin window
{
outputWin.document.write (text);
}


function h_link (node, text)
// Creates a link to file _node_ with text _text_.
{
 function h_makeUrl(nnode)
 {if (nnode == 'javascript:void(0)')
    return (nnode);
  if (nnode.substring(nnode.lastIndexOf('/'),nnode.length).indexOf('.') == -1)
    nnode += connectWin.h_filesExtComp;
  if (nnode.charAt(0) == '/')
     if (connectWin.baseDirectory != '/') 
     return(connectWin.baseDirectory + nnode);
   else
     return(nnode.substring(1,nnode.length));
  else
    return(h_thisDirectory() + '/' + nnode);
 }

if (node == null)
  {
  if (deadLinkPopup == false) 
    popupText = null;
  else
    if (popupText == null && titlePopup == true)
      if (typeof(connectWin.titleArray['deadLink']) != "undefined")
        popupText = connectWin.titleArray['deadLink'];
  if (deadLinkStatus == false)
    statusText = null;
  else
    if (statusText == null && titleStatus == true)
      if (typeof(connectWin.titleArray['deadLink']) != "undefined")
        statusText = connectWin.titleArray['deadLink'];
  if (popupText == null && statusText == null)
    {
    if (deadLinkStyle == "link")
      {var Btag = "<U>"; var Etag = "</U>";}
    else
      {var Btag = ""; var Etag = "";}
  if (deadLinkColor != null)
    {
    var begin_font_tag = '<FONT color="' + deadLinkColor + '">';
    var end_font_tag = "</FONT>";
    }
  else
    {
    var begin_font_tag = "";
    var end_font_tag = "";
    }
    h_write (begin_font_tag + Btag + text + Etag + end_font_tag);
    return (true);
    }
  node = "javascript:void(0)";
  linkColor = deadLinkColor;
  if (deadLinkStyle != "link")
    linkClass = "text";
  }
else
  {
  if (popupText == null && titlePopup == true)
    if (typeof(connectWin.titleArray[node]) != "undefined")
      popupText = connectWin.titleArray[node];
  if (statusText == null && titleStatus == true)
    if (typeof(connectWin.titleArray[node]) != "undefined")
      statusText = conectWin.titleArray[node];
  }

if (linkColor != null)
  {
  var begin_font_tag = '<FONT color="' + linkColor + '">';
  var end_font_tag = "</FONT>";
  }
else
  {
  var begin_font_tag = "";
  var end_font_tag = "";
  }

h_write (linkPrefix + '<A href=' + h_makeUrl(node));
if (linkClass != null)
  h_write(" class='" + linkClass + "'");
if (statusText != null || popupText != null)
  h_write(" onMouseOver='");
if (statusText != null)
  h_write("statusWin.status=" + '"' + statusText + '";');
if (popupText != null)
  h_write("h_show(" + '"pop' + h_popnb.toString() + '"' + ");");
if (statusText != null || popupText != null)
  h_write(" return true' onMouseOut='");
if (statusText != null)
  h_write('statusWin.status="";');
if (popupText != null)
  h_write ("h_hide(" + '"pop' + h_popnb.toString() + '"' + ");");
if (statusText != null || popupText != null)
  h_write(" return true'");
h_write (">" + begin_font_tag + text + end_font_tag + '</A>' + linkSuffix);
if (popupText != null)
  {
if (popupTextColor != null)
  {
  var begin_font_popup = '<FONT color="' + popupTextColor + '">';
  var end_font_popup = "</FONT>";
  }
else
  {
  var begin_font_popup = "";
  var end_font_popup = "";
  }
  h_write("<SPAN id=" + '"pop' + h_popnb.toString() + '"' + " CLASS='popup'><TABLE " + popupAtt + " bgcolor='" + popupBgColor + "'><TR><TD>" + begin_font_popup + popupText + end_font_popup + "</TD></TR></TABLE></SPAN>");  
  h_popnb++;
  }
linkColor = linkColorDefault;
linkClass = "link";
return (true);
}    

function link(node, text, cond, noNode, noText)
// If called with exactly 2 arguments then creates a link.
// If called with more than 2 arguments, then creates a 
// link to node _node_ with text _text_ if _cond_ holds.
// If _cond_ does not hold then, if _noText_ is specified 
// then creates a link to _noNode_ with text _noText_
// else, creates a link to _noNode_ with text _text_.
{
var arg_len = link.arguments.length;
if (arg_len == 2)
  h_link (node, text);
if (arg_len > 2)
  {
  if (cond)
    h_link (node, text);
  else 
    {
    if ( typeof(noText) != "undefined" )
      text = noText;
    if ( typeof(noNode) !="undefined" )
      h_link (noNode, text);
    }
  }

linkColor = linkColorDefault;
popupText = popupTextDefault;
statusText = statusTextDefault;
popupBgColor = popupBgColorDefault;
popupAtt = popupAttDefault;
popupTextColor = popupTextColorDefault;
linkPrefix = linkPrefixDefault;
linkSuffix = linkSuffixDefault;
linkClass = "link";
}


//
// Style definitions
//

// Style A.link: 
h_write("<style type='text/css'>A.link {" + linkCSS + "}</style>");

// Style A.annotatedText:
h_write("<style type='text/css'>A.annotatedText {" + annotatedTextCSS + "}</style>");

// Style A.text:
var textCSS = "text-decoration: none";
h_write("<style type='text/css'>A.text {" + textCSS + "}</style>");

// Style SPAN.popup
var popupCSS = "position: absolute; visibility: hidden;";
h_write("<style type='text/css'>SPAN.popup {"+ popupCSS + "}</style>");

if (typeof(executeAfterLoading) == "undefined")
  connectWin.executeAfterLoading();
else 
  executeAfterLoading();


















